<template>
    <div class="content-header" v-loading.fullscreen.lock="fullscreenLoading">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1 class="m-0">Usuarios</h1>
                </div><!-- /.col -->
            </div><!-- /.row -->
        </div><!-- /.container-fluid -->

        <div class="card p-1">
            <div class="row">
                <div class="col-4">
                    <label class="mt-2">ID</label>
                    <vs-input v-model="filter_id" />
                </div>
                <div class="col-4">
                    <label class="mt-2">Estado</label>
                    <vs-select v-model="filter_status">
                        <vs-option></vs-option>
                        <vs-option v-for="item in estados" :key="item" :label="item" :value="item">
                            {{ item }}
                        </vs-option>
                    </vs-select>
                </div>
                <div class="col-4">
                    <label class="mt-2">Email</label>
                    <vs-input v-model="filter_date" />
                </div>
            </div>
            <div class="row mt-3">
                <div class="col-2">
                    <button type="button" class="btn btn-info" @click.prevent="getLista()">
                        <i class="fa fa-filter"></i> Filtrar
                    </button>
                </div>

                <div class="col-3">
                    <button type="button" class="btn btn-info" @click.prevent="showModalCreated()">
                        <i class="fa fa-plus"></i> Crear usuario
                    </button>
                </div>
            </div>
        </div>

        <div class="card">
            <template>
                <div class="center">
                    <vs-table>
                        <template #header>
                            <vs-input v-model="search" border placeholder="Buscar" />
                        </template>
                        <template #thead>
                            <vs-tr>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'id')">
                                    ID
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'nombre')">
                                    Nombre
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'email')">
                                    Email
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'estado')">
                                    Estado
                                </vs-th>
                                <vs-th sort @click="listas = $vs.sortData($event, listas, 'created_at')">
                                    Creado
                                </vs-th>
                                <vs-th>-</vs-th>
                            </vs-tr>
                        </template>
                        <template #tbody>
                            <vs-tr :key="i" v-for="(tr, i) in $vs.getPage($vs.getSearch(listas, search), page, max)"
                                :data="tr">
                                <vs-td>
                                    {{ tr.id }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.name }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.email }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.estado }}
                                </vs-td>
                                <vs-td>
                                    {{ tr.created_at }}
                                </vs-td>
                                <vs-td>
                                    <div class="btn-group">
                                        <button type="button" class="btn btn-info" @click.prevent="showModalView(tr)">
                                            <i class="fa fa-eye"></i>
                                        </button>
                                        <button type="button" class="btn btn-primary" @click.prevent="showModalUpdate(tr)">
                                            <i class="fa fa-edit"></i>
                                        </button>
                                        <button type="button" class="btn btn-danger" @click.prevent="eliminarRegistro(tr)">
                                            <i class="fa fa-trash"></i>
                                        </button>
                                    </div>
                                </vs-td>
                            </vs-tr>
                        </template>
                        <template #footer>
                            <vs-pagination v-model="page" :length="$vs.getLength($vs.getSearch(listas, search), max)" />
                        </template>
                    </vs-table>
                </div>
            </template>
        </div>

        <vs-dialog overflow-hidden v-model="active_create">
            <template #header>
                <h4 class="not-margin text-primary">
                    Crear Usuario
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Nombre" v-model="name" />
                <br />
                <vs-input label-placeholder="Email" v-model="email" />
                <br />
                <vs-input label-placeholder="Contraseña" v-model="password" />
                <br />
                <label class="mt-2">Estado</label>
                <vs-select v-model="estado">
                    <vs-option v-for="item in estados" :key="item" :label="item" :value="item">
                        {{ item }}
                    </vs-option>
                </vs-select>
            </div>
            <template #footer>
                <div class="footer-dialog">
                    <vs-button block @click.prevent="submitCreated()">
                        Crear
                    </vs-button>
                </div>
            </template>
        </vs-dialog>

        <vs-dialog overflow-hidden v-model="active_update">
            <template #header>
                <h4 class="not-margin text-primary">
                    Editar Usuario
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Nombre" v-model="name" />
                <br />
                <vs-input label-placeholder="Email" v-model="email" disabled />
                <br />
                <vs-input label-placeholder="Contraseña" v-model="password" />
                <br />
                <label class="mt-2">Estado</label>
                <vs-select v-model="estado">
                    <vs-option></vs-option>
                    <vs-option v-for="item in estados" :key="item" :label="item" :value="item">
                        {{ item }}
                    </vs-option>
                </vs-select>
            </div>
            <template #footer>
                <div class="footer-dialog">
                    <vs-button block @click.prevent="submitUpdate()">
                        Actualizar
                    </vs-button>
                </div>
            </template>
        </vs-dialog>

        <vs-dialog overflow-hidden v-model="active_view">
            <template #header>
                <h4 class="not-margin text-primary">
                    Usuario {{ name }}
                </h4>
            </template>
            <div class="con-form">
                <vs-input label-placeholder="Nombre" v-model="name" disabled />
                <br />
                <vs-input label-placeholder="Descripción" v-model="email" disabled />
                <br />
                <vs-input label-placeholder="Estado" v-model="estado" disabled />
                <br />
            </div>
        </vs-dialog>
    </div>
</template>

<script>
export default {
    data: () => ({
        fullscreenLoading: false,
        page: 1,
        max: 5,
        search: '',
        estados: ['ACTIVO', 'DESHABILITADO'],
        active_update: false,
        active_view: false,
        active_create: false,
        listas: [],

        id: 0,
        name: '',
        email: '',
        estado: 'ACTIVO',
        password: '',
        created_at: '',

        filter_id: '',
        filter_status: '',
        filter_date: ''
    }),
    mounted() {
        this.getLista();
    },
    methods: {
        getLista() {
            this.fullscreenLoading = true;
            const url = '/users/index' +
                `?id=${this.filter_id}` +
                `&estado=${this.filter_status}` +
                `&created_at=${this.filter_date}`;
            axios.get(url)
                .then(response => {
                    this.listas = response.data;
                    this.fullscreenLoading = false;
                }).catch((er) => {
                    console.error(er);
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'danger', 'Error en servidor', 'Se presento un error al obtener los usuarios')
                });
        },
        showModalCreated() {
            this.active_create = true;
        },
        submitCreated() {
            this.fullscreenLoading = true;

            const data = {
                name: this.name,
                email: this.email,
                password: this.password,
                estado: this.estado
            };

            axios.post('/users', data)
                .then((res) => {
                    this.active_create = false;
                    this.clearFields();
                    this.openNotification('top-left', 'success', 'Petición exitosa', res.data.message);
                    this.getLista();
                }).catch((error) => {
                    this.fullscreenLoading = false;
                    let msg = this.msgErros(error);
                    this.openNotification('top-left', 'danger', 'Error en servidor', msg)
                });
        },
        showModalView(item) {
            this.fullscreenLoading = true;
            this.id = item.id;
            axios.get('/users/' + this.id)
                .then(response => {
                    this.fullscreenLoading = false;
                    const { name, email, estado, created_at } = response.data;

                    this.name = name;
                    this.email = email;
                    this.estado = estado;
                    this.created_at = created_at;

                    this.active_view = true;
                }).catch((er) => {
                    console.error(er);
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'danger', 'Error en servidor', 'Se presento un error al obtener las orden')
                });
        },
        showModalUpdate(item) {
            this.fullscreenLoading = true;
            this.id = item.id;
            axios.get('/users/' + this.id)
                .then(response => {
                    this.fullscreenLoading = false; 
                    
                    const { name, email, estado, created_at } = response.data;

                    this.name = name;
                    this.email = email;
                    this.estado = estado;
                    this.created_at = created_at;

                    this.active_update = true;
                }).catch((er) => {
                    console.error(er);
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'danger', 'Error en servidor', 'Se presento un error al obtener las orden')
                });
        },
        submitUpdate() {
            this.fullscreenLoading = true;

            const data = {
                name: this.name,
                password: this.password,
                estado: this.estado
            };

            axios.put('/users/update/' + this.id, data)
                .then((res) => {
                    this.active_update = false;
                    this.clearFields();
                    this.openNotification('top-left', 'success', 'Petición exitosa', res.data.message);
                    this.getLista();
                }).catch((error) => {
                    this.fullscreenLoading = false;
                    let msg = this.msgErros(error);
                    this.openNotification('top-left', 'danger', 'Error en servidor', msg)
                });
        },
        eliminarRegistro(item) {
            this.$swal.fire({
                title: '¿Estás seguro de eliminar al usuario ' + item.name + '?',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Eliminar',
                cancelButtonText: 'Cancelar',
            }).then((result) => {
                if (result.isConfirmed) {
                    this.submitDelete(item);
                }
            });
        },
        submitDelete(item) {
            this.fullscreenLoading = true;
            axios.delete('/users/' + item.id)
                .then((res) => {
                    this.fullscreenLoading = false;
                    this.openNotification('top-left', 'success', 'Petición exitosa', res.data.message);
                    this.getLista();
                }).catch((error) => {
                    this.fullscreenLoading = false;
                    let msg = this.msgErros(error);
                    this.openNotification('top-left', 'danger', 'Error en servidor', msg)
                });
        },
        openNotification(position = null, color, title, text) {
            this.$vs.notification({
                color,
                position,
                title: title,
                text: text
            });
        },
        clearFields() {
            this.id = '';
            this.email = '';
            this.name = '';
            this.created_at = '';
            this.estado = '';
            this.password = '';
        },
        msgErros(error) {
            let msg = "";
            if (error.response) {
                console.error(error.response.data);
                const serverErrors = error.response.data.errors;
                for (const field in serverErrors) {
                    msg += `${field}: ${serverErrors[field][0]}<br/>`;
                }
            } else {
                msg = 'No se logro actualizar la orden';
            }
            return msg;
        }
    }
}
</script>